package cz.vity.freerapid.plugins.services.RSDF;

import cz.vity.freerapid.plugins.services.RSDF.crypt.AESencrypt;
import cz.vity.freerapid.plugins.services.RSDF.crypt.Base64;
import cz.vity.freerapid.plugins.webclient.AbstractRunner;
import cz.vity.freerapid.plugins.webclient.DownloadState;
import java.io.BufferedReader;
import java.io.FileReader;
import java.net.URI;
import java.net.URL;
import java.util.LinkedList;
import java.util.List;
import org.apache.commons.httpclient.methods.GetMethod;

import java.util.logging.Logger;

/**
 * @author benpicco
 * 
 * Thanks to Kugelfisch23 for finding the key and help with AES
 * 
 */
class RSDFFileRunner extends AbstractRunner {
    // The key used to encrypt RSDF containers
    private static final byte[] keyData = StringToHex("8C35192D964DC3182C6F84F3252239EB4A320D2500000000"); //Base64.decode("c281c3hOc1BLZk5TRERaSGF5cjMyNTIw");
    private static final byte[] iv      = StringToHex("A3D5A33CB95AC1F5CBDB1AD25CB0A7AA");
    
    private final static Logger logger = Logger.getLogger(RSDFFileRunner.class.getName());

   private static byte cth(char ch) {
      if (ch >= '0' && ch <= '9') return (byte) (ch - '0');
      if (ch >= 'a' && ch <= 'f') return (byte) (ch - 'a' + 10);
      if (ch >= 'A' && ch <= 'F') return (byte) (ch - 'A' + 10);
      return 0;
   }
   
    private static byte[] StringToHex(String s) {
      byte[] out = new byte[s.length()/2];
      for(int i=0; i<s.length(); i+=2)
         out[i/2] = (byte) (16 * cth(s.charAt(i)) + cth(s.charAt(i + 1)));

      return out;
    }
    
    public static String HexToStr (String x) {
        StringBuilder result = new StringBuilder();
        for (int i = 0; i < x.length(); i = i + 2)
            result.append((char)(Integer.decode("0x" + x.substring(i, i+2))).intValue());

        return result.toString();
    } 
    
    private static void shift(byte[] arr, byte b) {
        for(int i=0; i < arr.length - 1; i++)
            arr[i]=arr[i+1];
        arr[arr.length-1] = b;
    }

    // Cipher Feedback (8 bit) 
    private static byte[] decrypt_CFB8(byte[] cipher) {
        int blockSize = 16;        
        byte[] key = keyData;
        
        byte[] decrypt = new byte[cipher.length];            
        byte[] output  = new byte[blockSize];   
        
        AESencrypt aes = new AESencrypt(key, 6);
        
        byte[] state = iv;
        for(int i=0; i<cipher.length; i++) {
            aes.Cipher(state, output);          
            decrypt[i] = (byte) (cipher[i] ^ output[0]);
            shift(state, cipher[i]);
        }
        return decrypt;
    }

    @Override
    public void run() throws Exception {
        super.run();
        
        String content = "";
        
        if(fileURL.startsWith("http://")) { // try downloading the rsdf file
            logger.info("Starting download in TASK " + fileURL);
            final GetMethod getMethod = getGetMethod(fileURL);
            if (makeRedirectedRequest(getMethod)) {
                content = getContentAsString();
            }
        } else { // open rsdf file locally 
            logger.info("Opening file " + fileURL);
            BufferedReader reader = new BufferedReader (new FileReader(fileURL));

            while (reader.ready())
                content += reader.readLine();
            reader.close();
        }
        
        content = HexToStr(content);
        
        List<byte[]> encrypted = new LinkedList<byte[]>();
        
        int size = 0;
        for(String link : content.split("\r\n")) {
            byte[] lnk = Base64.decode(link);
            size+=lnk.length;
            encrypted.add(lnk);
        }
        
        byte[] encData = new byte[size];
        
        int i=0;
        for(byte[] date : encrypted)          
            for(byte b : date)
                encData[i++] = b;
                
         List<URI> uriList = new LinkedList<URI>();

            
        String plaintext = new String(decrypt_CFB8(encData));
        for(String link : plaintext.split("CCF: "))
            if(!link.isEmpty()) {
                //logger.info("Encrypted: "+link);
                uriList.add(new URI(link));
            }
                   
        // We converti this download task in order to keep the list clean
        String url = uriList.remove(0).toString();
        getPluginService().getPluginContext().getQueueSupport().addLinksToQueue(httpFile, uriList);
        this.httpFile.setNewURL(new URL(url));       
        this.httpFile.setPluginID("");
        this.httpFile.setState(DownloadState.QUEUED);
    }
}
